
/**
 * Dependencies
 */
var _       = require('lodash');
var fs      = require('vinyl-fs');
var map     = require('map-stream');
var path    = require('path');
var q       = require('q');

/**
 * Local dependencies
 */
var mm = require('./mightymite');
var util = require('./utilities');

module.exports.init = function() {

    var def = q.defer();

    mm.data = {};

    // Grab data files in the data directory
    var src = path.resolve(mm.config.dataDir, '**/*.' + util.globFromArray(mm.config.dataTypes) + '');

    fs.src(src)
        .pipe(map(function(file, callback) {

            addData(file, callback);
        }))
        .on('end', function() {
            def.resolve();
        });

    return def.promise;
};

var addData = function(file, callback) {

    var dataPath = util.getDotPath(file, mm.config.dataDir);

    mm.data[dataPath] = require(file.path);

    callback();
};
