
/**
 * Dependencies
 */
var _       = require('lodash');
var q       = require('q');

/**
 * Local dependencies
 */
var build       = require('./build');
var data        = require('./data');
var pages       = require('./pages');
var templates   = require('./templates');
var mm          = require('./mightymite');

module.exports = function(options, callback) {

    // Initialize MightyMite
    mm.init(options);

    // Run task sequence
    setupTasks(function() {
        templateTasks(function() {
            buildTasks(function() {
                callback();
            });
        });
    });
};

var setupTasks = function(callback) {

    q.all([
        pages.init(),
        data.init(),
    ]).done(callback);
};

var templateTasks = function(callback) {

    q.all([
        templates.init(),
    ]).done(callback);
};

var buildTasks = function(callback) {

    q.all([
        build.init(),
    ]).done(callback);
};
